package io.zipcoder.interfaces;

import org.junit.Assert;
import org.junit.Test;

public class TestPeople {

    Person person1,person2;
    Student student1;
    Instructor instructor;
    Students students;
    Instructors instructors;

    public TestPeople() {
        students = Students.getInstance();
        person1 = new Person("person1", 45);
        person2 = new Person("person2", 55);
        student1 = new Student("student1", 50);
        instructor = new Instructor("instructor1", 54);
        students.add(student1);
    }

    @Test
    public void testAdd(){
        //Given
        Student newStudent = new Student("student2", 42);

        //When
        Integer expected = 41;
        students.add(newStudent);
        Integer actual = students.getCount();

        //Then
        Assert.assertEquals(expected,actual);
    }

    @Test
    public void testFindById(){
        //When
        long expected = student1.getId();
        Student actual = students.findById(50);

        //Then
        Assert.assertEquals(expected,actual.getId());
    }

    @Test
    public void testRemoveTest(){
        //When
        Integer expected = 42;
        students.removeById(50);
        Integer actual = students.getCount();

        //Then
        Assert.assertEquals(expected,actual);
    }

    @Test
    public void testRemoveAll(){
        //Given
        Instructors instructors = Instructors.getInstance();

        //When
        Integer expected = 4;
        instructors.removeAll();
        Integer actual = instructors.getCount();

        //Then
        Assert.assertEquals(expected,actual);

    }



}
